/* USER CODE BEGIN Header */
/**
  ******************************************************************************
  * @file           : main.c
  * @brief          : Main program body
  ******************************************************************************
  * @attention
  *
  * <h2><center>&copy; Copyright (c) 2022 STMicroelectronics.
  * All rights reserved.</center></h2>
  *
  * This software component is licensed by ST under Ultimate Liberty license
  * SLA0044, the "License"; You may not use this file except in compliance with
  * the License. You may obtain a copy of the License at:
  *                             www.st.com/SLA0044
  *
  ******************************************************************************
  */
/* USER CODE END Header */
/* Includes ------------------------------------------------------------------*/
#include "main.h"

/* Private includes ----------------------------------------------------------*/
/* USER CODE BEGIN Includes */

//#include "ds18b20Config.h"
//#include "ds18b20.h"
#include "string.h"
#include "onewire.h"
OneWire_t OneWire;
/* USER CODE END Includes */

/* Private typedef -----------------------------------------------------------*/
/* USER CODE BEGIN PTD */

/* USER CODE END PTD */

/* Private define ------------------------------------------------------------*/
/* USER CODE BEGIN PD */
void 		write_array(uint8_t* arr,int num,int sensor_no);
void 		read_response(int num);
uint8_t  	sensors_Init(void);
void 		AMR(int s_num);
float 		get_temperature_deg(int sensor_num);
void 		init_th_sensor(int sensor_num);
float 		get_temperature_far(int sensor_num);
float 		get_humidity(int sensor_num );
/* USER CODE END PD */

/* Private macro -------------------------------------------------------------*/
/* USER CODE BEGIN PM */

/* USER CODE END PM */

/* Private variables ---------------------------------------------------------*/
TIM_HandleTypeDef htim7;

UART_HandleTypeDef huart2;
UART_HandleTypeDef huart3;

/* USER CODE BEGIN PV */
//======================================================================================
struct sensor
{
 uint8_t address[8];
};

struct sensor_d
{
	float tempc;
	float tempf;
	float hum;
};

int ret;
struct sensor   	s1,s2,s3,s4,s5,s6,s7,s8;
struct sensor_d  	sr_data[8];
uint16_t 			result,result1;
float 				temperature,temperature_f,humidity;
uint8_t 			flag=0;
//================================================================================================================
uint8_t command_1[11]               =  {0xCC,0x66,0x05,0x83,0x0B,0x03,0xA5,0x0F,0x75,0x02,0xAA};
uint8_t command_2[19]               =  {0x55,0x56,0xBC,0xE8,0x00,0x00,0x00,0x00,0x2C,0x66,0x05,0x83,0x0B,0x03,0xA5,0x0F,0x75,0x02,0xAA};
uint8_t command_3[15]               =  {0x55,0x56,0xBC,0xE8,0x00,0x00,0x00,0x00,0x2C,0x66,0x01,0x7A,0x9F,0x93,0xAA};
uint8_t command_4[15]               =  {0x55,0x56,0xBC,0xE8,0x00,0x00,0x00,0x00,0x2C,0x66,0x01,0x6A,0x9E,0x5F,0xAA};
uint8_t command_5[16]               =  {0x55,0x56,0xBC,0xE8,0x00,0x00,0x00,0x00,0x2C,0x66,0x02,0x55,0x01,0xFE,0x26,0xAA};
uint8_t command_6[38]               = {0x55,0x56,0xBC,0xE8,0x00,0x00,0x00,0x00,0x2C, 0x66, 0x18, 0x11, 0x00, 0x00,0x02, 0xE3, 0x02, 0x88, 0xFD,0x03,0xDD, 0x08,0x02, 0xE3, 0x01, 0x89, 0xD4, 0x06, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x03,0xC8, 0x30, 0xAA};
uint8_t command_7[17]               = {0x55,0x56,0xBC,0xE8,0x00,0x00,0x00,0x00,0x2C, 0x66, 0x03, 0x22, 0x00, 0x2A, 0xD6, 0x69, 0xAA};
uint8_t command_8[18]               = {0x55,0x56,0xBC,0xE8,0x00,0x00,0x00,0x00,0x2C, 0x66, 0x04, 0x33, 0x00, 0x2A, 0x00, 0x18, 0xDD, 0xAA};
uint8_t command_9[17]               = {0x55,0x56,0xBC,0xE8,0x00,0x00,0x00,0x00,0x2C,0x66, 0x03, 0x22, 0x0E, 0x0C, 0x5D, 0xBC, 0xAA};
//===============================================================================================================
int 		SensorCount =0;
int 		OneWireDevices=0;
uint8_t 	i;
uint8_t 	present = 0;
uint8_t 	data[12];
uint8_t 	addr[8];

//======================================================================================

/* USER CODE END PV */

/* Private function prototypes -----------------------------------------------*/
void SystemClock_Config(void);
static void MX_GPIO_Init(void);
static void MX_TIM7_Init(void);
static void MX_USART3_UART_Init(void);
static void MX_USART2_UART_Init(void);
/* USER CODE BEGIN PFP */

/* USER CODE END PFP */

/* Private user code ---------------------------------------------------------*/
/* USER CODE BEGIN 0 */
//==============================================================================
void write_array(uint8_t* arr,int num,int sensor_no)
{
	OneWire_Reset(&OneWire);
  for(int i = 0;i<num;i++)
  {
	  OneWire_WriteByte(&OneWire, arr[i]);
  }
 HAL_Delay(100);
}

void read_response(int num)
{
  uint8_t arr[42];
  for(int i = 0;i<num;i++)
  {
    arr[i] = OneWire_ReadByte(&OneWire);
  }
  if(flag==1)
  {
    result = (  arr[3]<< 8);
    result |=arr[4] ;
     result1 = (  arr[6]<< 8);
    result1 |=arr[7] ;

    temperature= (float)(-45 + 175 / 65535.0 * (float)result);
    temperature_f= (float)(-49 + 315 / 65535.0 * (float)result);
    humidity= (float)(-6 + 125 / 65535.0 * (float)result1);

  }
  HAL_Delay(200);
}


//=========================================================================================
uint8_t  sensors_Init(void)
{
 uint8_t TryToFind=5;
 do
 {
   OneWire_Init(&OneWire,One_Wire_GPIO_Port ,One_Wire_Pin);
   SensorCount = 0;
   OneWireDevices = OneWire_First(&OneWire);
   while (OneWireDevices)
   {
     HAL_Delay(100);
     SensorCount++;
     switch (SensorCount)
     {
     case 1 :
    	 OneWire_GetFullROM(&OneWire, s1.address);
    	 break;
     case 2 :
    	 OneWire_GetFullROM(&OneWire, s2.address);
    	 break;
     case 3 :
    	 OneWire_GetFullROM(&OneWire, s3.address);
    	 break;
     case 4 :
    	 OneWire_GetFullROM(&OneWire, s4.address);
    	 break;
     case 5 :
     	 OneWire_GetFullROM(&OneWire, s5.address);
    	 break;
     case 6 :
     	 OneWire_GetFullROM(&OneWire, s6.address);
    	 break;
     case 7 :
     	 OneWire_GetFullROM(&OneWire, s7.address);
    	 break;
     case 8 :
     	 OneWire_GetFullROM(&OneWire, s8.address);
    	 break;
     default:
    	 break;
     }
     OneWireDevices = OneWire_Next(&OneWire);
   }

   if(SensorCount>0)
     break;
   TryToFind--;
 }while(TryToFind>0);
 if(TryToFind==0)
 {
   return 0;
 }
 return 1;
}


//=========================================================================================
void AMR(int s_num)
{
 switch (s_num)
   {
     case 1 :
             for ( i = 0; i < 8; i++)
             {
               command_2[i+1] = s1.address[i];
               command_3[i+1] = s1.address[i];
               command_4[i+1] = s1.address[i];
               command_5[i+1] = s1.address[i];
               command_6[i+1] = s1.address[i];
               command_7[i+1] = s1.address[i];
               command_8[i+1] = s1.address[i];
               command_9[i+1] = s1.address[i];
              }
             break;
    case 2 :
             for ( i = 0; i < 8; i++)
             {
               command_2[i+1] = s2.address[i];
               command_3[i+1] = s2.address[i];
               command_4[i+1] = s2.address[i];
               command_5[i+1] = s2.address[i];
               command_6[i+1] = s2.address[i];
               command_7[i+1] = s2.address[i];
               command_8[i+1] = s2.address[i];
               command_9[i+1] = s2.address[i];
             }
             break;
    case 3 :
             for ( i = 0; i < 8; i++)
             {
               command_2[i+1] = s3.address[i];
               command_3[i+1] = s3.address[i];
               command_4[i+1] = s3.address[i];
               command_5[i+1] = s3.address[i];
               command_6[i+1] = s3.address[i];
               command_7[i+1] = s3.address[i];
               command_8[i+1] = s3.address[i];
               command_9[i+1] = s3.address[i];
            }
             break;
    case 4 :
             for ( i = 0; i < 8; i++)
             {
               command_2[i+1] = s4.address[i];
               command_3[i+1] = s4.address[i];
               command_4[i+1] = s4.address[i];
               command_5[i+1] = s4.address[i];
               command_6[i+1] = s4.address[i];
               command_7[i+1] = s4.address[i];
               command_8[i+1] = s4.address[i];
               command_9[i+1] = s4.address[i];
             }
             break;
    case 5 :
             for ( i = 0; i < 8; i++)
             {
               command_2[i+1] = s5.address[i];
               command_3[i+1] = s5.address[i];
               command_4[i+1] = s5.address[i];
               command_5[i+1] = s5.address[i];
               command_6[i+1] = s5.address[i];
               command_7[i+1] = s5.address[i];
               command_8[i+1] = s5.address[i];
               command_9[i+1] = s5.address[i];
             }
             break;
    case 6 :
             for ( i = 0; i < 8; i++)
             {
              command_2[i+1]  = s6.address[i];
               command_3[i+1] = s6.address[i];
               command_4[i+1] = s6.address[i];
               command_5[i+1] = s6.address[i];
               command_6[i+1] = s6.address[i];
               command_7[i+1] = s6.address[i];
               command_8[i+1] = s6.address[i];
               command_9[i+1] = s6.address[i];
             }
             break;
    case 7 :
             for ( i = 0; i < 8; i++)
             {
               command_2[i+1] = s7.address[i];
               command_3[i+1] = s7.address[i];
               command_4[i+1] = s7.address[i];
               command_5[i+1] = s7.address[i];
               command_6[i+1] = s7.address[i];
               command_7[i+1] = s7.address[i];
               command_8[i+1] = s7.address[i];
               command_9[i+1] = s7.address[i];
             }
             break;
   case 8 :
             for ( i = 0; i < 8; i++)
             {
               command_2[i+1] = s8.address[i];
               command_3[i+1] = s8.address[i];
               command_4[i+1] = s8.address[i];
               command_5[i+1] = s8.address[i];
               command_6[i+1] = s8.address[i];
               command_7[i+1] = s8.address[i];
               command_8[i+1] = s8.address[i];
               command_9[i+1] = s8.address[i];
             }
             break;
   default:
             break;
   }

}
//=========================================================================================
void init_th_sensor(int sensor_num)
{
 AMR(sensor_num);
 write_array(command_1,11,sensor_num);
 HAL_Delay(900);
 write_array(command_2,19,sensor_num);
 read_response(5);
 write_array(command_3,15,sensor_num);
 read_response(9);
 write_array(command_5,16,sensor_num);
 read_response(5);
 write_array(command_4,15,sensor_num);
 read_response(6);
 flag=0;
 write_array(command_6,38,sensor_num);
 read_response(5);
 write_array(command_7,17,sensor_num);
 read_response(24);
}
//==========================================================================================
float get_temperature_deg(int sensor_num)
{
 AMR(sensor_num);
 write_array(command_8,18,sensor_num);
 flag =0;
 read_response(7);
 write_array(command_9,17,sensor_num);
 flag=1;
 read_response(10);
 return temperature;
}

//==========================================================================================

float get_temperature_far(int sensor_num)
{
 AMR(sensor_num);
 write_array(command_8,18,sensor_num);
 flag =0;
 read_response(7);
 write_array(command_9,17,sensor_num);
 flag=1;
 read_response(10);
 return temperature_f;
}

//==========================================================================================


float get_humidity(int sensor_num )
{
 AMR(sensor_num);
 write_array(command_8,18,sensor_num);
 flag =0;
 read_response(7);
 write_array(command_9,17,sensor_num);
 flag=1;
 read_response(10);
 return humidity;
}

//==============================================================================

//================================================================================================================




/* USER CODE END 0 */

/**
  * @brief  The application entry point.
  * @retval int
  */
int main(void)
{
  /* USER CODE BEGIN 1 */

  /* USER CODE END 1 */

  /* MCU Configuration--------------------------------------------------------*/

  /* Reset of all peripherals, Initializes the Flash interface and the Systick. */
  HAL_Init();

  /* USER CODE BEGIN Init */

  /* USER CODE END Init */

  /* Configure the system clock */
  SystemClock_Config();

  /* USER CODE BEGIN SysInit */

  /* USER CODE END SysInit */

  /* Initialize all configured peripherals */
  MX_GPIO_Init();
  MX_TIM7_Init();
  MX_USART3_UART_Init();
  MX_USART2_UART_Init();
  /* USER CODE BEGIN 2 */
  ret = sensors_Init();
  if(ret)
  {
	  for(int sr = 1;sr <= SensorCount; sr++)
	    {
	      init_th_sensor(sr);
	    }
  }
  /* USER CODE END 2 */

  /* Infinite loop */
  /* USER CODE BEGIN WHILE */
  while (1)
  {
	  	if(SensorCount > 0)
	    {
	        for(int sr = 1;sr <= SensorCount; sr++)
	        {
	        	sr_data[sr].tempc = get_temperature_deg(sr);
	        	sr_data[sr].tempf = get_temperature_far(sr);
	        	sr_data[sr].hum   = get_humidity(sr);
	        }
	    }
	    else
	    {
	      HAL_Delay(100);
	    }
    /* USER CODE END WHILE */

    /* USER CODE BEGIN 3 */
  }
  /* USER CODE END 3 */
}

/**
  * @brief System Clock Configuration
  * @retval None
  */
void SystemClock_Config(void)
{
  RCC_OscInitTypeDef RCC_OscInitStruct = {0};
  RCC_ClkInitTypeDef RCC_ClkInitStruct = {0};

  /** Configure the main internal regulator output voltage
  */
  __HAL_RCC_PWR_CLK_ENABLE();
  __HAL_PWR_VOLTAGESCALING_CONFIG(PWR_REGULATOR_VOLTAGE_SCALE1);
  /** Initializes the RCC Oscillators according to the specified parameters
  * in the RCC_OscInitTypeDef structure.
  */
  RCC_OscInitStruct.OscillatorType = RCC_OSCILLATORTYPE_HSE;
  RCC_OscInitStruct.HSEState = RCC_HSE_ON;
  RCC_OscInitStruct.PLL.PLLState = RCC_PLL_ON;
  RCC_OscInitStruct.PLL.PLLSource = RCC_PLLSOURCE_HSE;
  RCC_OscInitStruct.PLL.PLLM = 8;
  RCC_OscInitStruct.PLL.PLLN = 432;
  RCC_OscInitStruct.PLL.PLLP = RCC_PLLP_DIV6;
  RCC_OscInitStruct.PLL.PLLQ = 7;
  if (HAL_RCC_OscConfig(&RCC_OscInitStruct) != HAL_OK)
  {
    Error_Handler();
  }
  /** Initializes the CPU, AHB and APB buses clocks
  */
  RCC_ClkInitStruct.ClockType = RCC_CLOCKTYPE_HCLK|RCC_CLOCKTYPE_SYSCLK
                              |RCC_CLOCKTYPE_PCLK1|RCC_CLOCKTYPE_PCLK2;
  RCC_ClkInitStruct.SYSCLKSource = RCC_SYSCLKSOURCE_PLLCLK;
  RCC_ClkInitStruct.AHBCLKDivider = RCC_SYSCLK_DIV1;
  RCC_ClkInitStruct.APB1CLKDivider = RCC_HCLK_DIV2;
  RCC_ClkInitStruct.APB2CLKDivider = RCC_HCLK_DIV2;

  if (HAL_RCC_ClockConfig(&RCC_ClkInitStruct, FLASH_LATENCY_2) != HAL_OK)
  {
    Error_Handler();
  }
}

/**
  * @brief TIM7 Initialization Function
  * @param None
  * @retval None
  */
static void MX_TIM7_Init(void)
{

  /* USER CODE BEGIN TIM7_Init 0 */

  /* USER CODE END TIM7_Init 0 */

  TIM_MasterConfigTypeDef sMasterConfig = {0};

  /* USER CODE BEGIN TIM7_Init 1 */

  /* USER CODE END TIM7_Init 1 */
  htim7.Instance = TIM7;
  htim7.Init.Prescaler = 10-1;
  htim7.Init.CounterMode = TIM_COUNTERMODE_UP;
  htim7.Init.Period = 0xffff-1;
  htim7.Init.AutoReloadPreload = TIM_AUTORELOAD_PRELOAD_ENABLE;
  if (HAL_TIM_Base_Init(&htim7) != HAL_OK)
  {
    Error_Handler();
  }
  sMasterConfig.MasterOutputTrigger = TIM_TRGO_RESET;
  sMasterConfig.MasterSlaveMode = TIM_MASTERSLAVEMODE_DISABLE;
  if (HAL_TIMEx_MasterConfigSynchronization(&htim7, &sMasterConfig) != HAL_OK)
  {
    Error_Handler();
  }
  /* USER CODE BEGIN TIM7_Init 2 */

  /* USER CODE END TIM7_Init 2 */

}

/**
  * @brief USART2 Initialization Function
  * @param None
  * @retval None
  */
static void MX_USART2_UART_Init(void)
{

  /* USER CODE BEGIN USART2_Init 0 */

  /* USER CODE END USART2_Init 0 */

  /* USER CODE BEGIN USART2_Init 1 */

  /* USER CODE END USART2_Init 1 */
  huart2.Instance = USART2;
  huart2.Init.BaudRate = 115200;
  huart2.Init.WordLength = UART_WORDLENGTH_8B;
  huart2.Init.StopBits = UART_STOPBITS_1;
  huart2.Init.Parity = UART_PARITY_NONE;
  huart2.Init.Mode = UART_MODE_TX_RX;
  huart2.Init.HwFlowCtl = UART_HWCONTROL_NONE;
  huart2.Init.OverSampling = UART_OVERSAMPLING_16;
  if (HAL_UART_Init(&huart2) != HAL_OK)
  {
    Error_Handler();
  }
  /* USER CODE BEGIN USART2_Init 2 */

  /* USER CODE END USART2_Init 2 */

}

/**
  * @brief USART3 Initialization Function
  * @param None
  * @retval None
  */
static void MX_USART3_UART_Init(void)
{

  /* USER CODE BEGIN USART3_Init 0 */

  /* USER CODE END USART3_Init 0 */

  /* USER CODE BEGIN USART3_Init 1 */

  /* USER CODE END USART3_Init 1 */
  huart3.Instance = USART3;
  huart3.Init.BaudRate = 9600;
  huart3.Init.WordLength = UART_WORDLENGTH_8B;
  huart3.Init.StopBits = UART_STOPBITS_1;
  huart3.Init.Parity = UART_PARITY_NONE;
  huart3.Init.Mode = UART_MODE_TX_RX;
  huart3.Init.HwFlowCtl = UART_HWCONTROL_NONE;
  huart3.Init.OverSampling = UART_OVERSAMPLING_16;
  if (HAL_HalfDuplex_Init(&huart3) != HAL_OK)
  {
    Error_Handler();
  }
  /* USER CODE BEGIN USART3_Init 2 */

  /* USER CODE END USART3_Init 2 */

}

/**
  * @brief GPIO Initialization Function
  * @param None
  * @retval None
  */
static void MX_GPIO_Init(void)
{
  GPIO_InitTypeDef GPIO_InitStruct = {0};

  /* GPIO Ports Clock Enable */
  __HAL_RCC_GPIOC_CLK_ENABLE();
  __HAL_RCC_GPIOH_CLK_ENABLE();
  __HAL_RCC_GPIOA_CLK_ENABLE();
  __HAL_RCC_GPIOB_CLK_ENABLE();
  __HAL_RCC_GPIOD_CLK_ENABLE();

  /*Configure GPIO pin Output Level */
  HAL_GPIO_WritePin(OTG_FS_PowerSwitchOn_GPIO_Port, OTG_FS_PowerSwitchOn_Pin, GPIO_PIN_SET);

  /*Configure GPIO pin Output Level */
  HAL_GPIO_WritePin(GPIOD, LD4_Pin|LD3_Pin|LD5_Pin|LD6_Pin, GPIO_PIN_RESET);

  /*Configure GPIO pin Output Level */
  HAL_GPIO_WritePin(One_Wire_GPIO_Port, One_Wire_Pin, GPIO_PIN_SET);

  /*Configure GPIO pin : OTG_FS_PowerSwitchOn_Pin */
  GPIO_InitStruct.Pin = OTG_FS_PowerSwitchOn_Pin;
  GPIO_InitStruct.Mode = GPIO_MODE_OUTPUT_PP;
  GPIO_InitStruct.Pull = GPIO_NOPULL;
  GPIO_InitStruct.Speed = GPIO_SPEED_FREQ_LOW;
  HAL_GPIO_Init(OTG_FS_PowerSwitchOn_GPIO_Port, &GPIO_InitStruct);

  /*Configure GPIO pin : B1_Pin */
  GPIO_InitStruct.Pin = B1_Pin;
  GPIO_InitStruct.Mode = GPIO_MODE_EVT_RISING;
  GPIO_InitStruct.Pull = GPIO_NOPULL;
  HAL_GPIO_Init(B1_GPIO_Port, &GPIO_InitStruct);

  /*Configure GPIO pin : BOOT1_Pin */
  GPIO_InitStruct.Pin = BOOT1_Pin;
  GPIO_InitStruct.Mode = GPIO_MODE_INPUT;
  GPIO_InitStruct.Pull = GPIO_NOPULL;
  HAL_GPIO_Init(BOOT1_GPIO_Port, &GPIO_InitStruct);

  /*Configure GPIO pins : LD4_Pin LD3_Pin LD5_Pin LD6_Pin */
  GPIO_InitStruct.Pin = LD4_Pin|LD3_Pin|LD5_Pin|LD6_Pin;
  GPIO_InitStruct.Mode = GPIO_MODE_OUTPUT_PP;
  GPIO_InitStruct.Pull = GPIO_NOPULL;
  GPIO_InitStruct.Speed = GPIO_SPEED_FREQ_LOW;
  HAL_GPIO_Init(GPIOD, &GPIO_InitStruct);

  /*Configure GPIO pin : One_Wire_Pin */
  GPIO_InitStruct.Pin = One_Wire_Pin;
  GPIO_InitStruct.Mode = GPIO_MODE_OUTPUT_OD;
  GPIO_InitStruct.Pull = GPIO_NOPULL;
  GPIO_InitStruct.Speed = GPIO_SPEED_FREQ_LOW;
  HAL_GPIO_Init(One_Wire_GPIO_Port, &GPIO_InitStruct);

}

/* USER CODE BEGIN 4 */

/* USER CODE END 4 */

/**
  * @brief  This function is executed in case of error occurrence.
  * @retval None
  */
void Error_Handler(void)
{
  /* USER CODE BEGIN Error_Handler_Debug */
  /* User can add his own implementation to report the HAL error return state */
  __disable_irq();
  while (1)
  {
  }
  /* USER CODE END Error_Handler_Debug */
}

#ifdef  USE_FULL_ASSERT
/**
  * @brief  Reports the name of the source file and the source line number
  *         where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(uint8_t *file, uint32_t line)
{
  /* USER CODE BEGIN 6 */
  /* User can add his own implementation to report the file name and line number,
     ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */
  /* USER CODE END 6 */
}
#endif /* USE_FULL_ASSERT */

